> ## Documentation Index
> Fetch the complete documentation index at: https://docs.chkk.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Get Package

> Gets a single Package

A <em>Package</em> is a named bundle of software that is bundled (and
identified) in the format of a specific PackageSystem.

A <em>PackageSystem</em> is an identifier of a packaging ecosystem.

Packages can use one of the following PackageSystems:

* <b>helm</b> for Helm charts
* <b>kube</b> for raw YAML manifests or Kustomize overlays that install one or
  more resources

A Package is identified by a globally-unique ID field which is a UUID string
prefixed with the string 'pkg_', for example
'pkg_c42014e7-baf5-4ec6-a502-858f98dca7c8'.

A Package may be associated with one or more Projects and zero or more
ProjectComponents.

A Package may have one or more links associated with it. There are two types
of links that hold special significance to a package: 'package.archive' and
'package.source'. The 'package.archive' link is used to indicate the location
of the package's archive, which is the file that contains the package's
contents. The 'package.source' link is used to indicate a location on the web
where the package may be observed in an un-archived format. For example, the
cert-manager helm chart package can have the following links

- 'package.archive': https:charts.jetstack.io/cert-manager
- 'package.source': https:github.com/cert-manager/cert-manager/tree/master/deploy/charts/cert-manager

A Package may have zero or more aliases associated with it in the 'Aliases'
field. An alias for a Package is a human readable string that uniquely
identifies the Package.

A Package may be associated with one or more ProjectComponents. Packages with
PackageSystem <b>helm</b> or <b>kube</b> are associated with ProjectComponents
via the Package's collection of PackageComponents. A PackageComponent, which
corresponds to a specific Resource of Kind Deployment, DaemonSet or
StatefulSet, may reference one or more Docker Images. Those Docker Images
correspond to a ProjectComponent for one or more Projects.




## OpenAPI

````yaml get /packages/{package}/
openapi: 3.1.0
info:
  description: >

    The Chkk Artifact Register API exposes information about the artifacts in a

    customer's clusters.


    Data models exposed in the Chkk Artifact Register API include:


    * <b>Organization</b>: the top-level object that models a Chkk customer.

    * <b>Account</b>: a container for resource ownership within an Organization.

    * <b>KubePlatform</b>: describes things like the cloud infrastructure
    provider
      and the control plane provider.
    * <b>KubeCluster</b>: a single cluster provisioned by a
      KubePlatform.
    * <b>KubeClusterScan</b>: a single Chkk scan of a cluster.

    * <b>KubeClusterResource</b>: a single Resource
      (Deployment, DaemonSet or StatefulSet) from a KubeClusterScan.
    * <b>KubeClusterResourceContainer</b>: a single container record in a
      KubeClusterResource.
    * <b>Project</b>: software that provides some functionality.

    * <b>ProjectReleaseSeries</b>: a single release series for a Project.

    * <b>ProjectRelease</b>: a single release for a Project.

    * <b>ProjectVersionSet</b>: a configuration, layout or structure of a
    Project
      that is consistent for a range of ProjectReleases.
    * <b>ProjectComponent</b>: a separate binary, daemon, or subsystem of a
      Project.
    * <b>Package</b>: a named bundle of software that is bundled (and
      identified) in the format of a specific PackageSystem.
    * <b>PackageRelease</b>: a single release for a Package.

    * <b>PackageVersionSet</b>: a configuration, layout or structure of a
    Package
      that is consistent for a range of PackageReleases.
    * <b>OCIRepository</b>: a single namespace within an OCI Registry.

    * <b>OCIArtifact</b>: a single OCI Artifact (manifest) that describes an OCI
      Image or other OCI Artifact.
    * <b>OCITag</b>: a name that points to a unique OCIArtifact within an
      OCIRepository.
    * <b>OCIReference</b>: a relationship between an OCITag and an OCIArtifact.

    * <b>RiskSignature</b>: the source of a <em>potential</em>
      availability or operational risk for a customer.
    * <b>Risk</b>: a <em>detected</em> RiskSignature for an Account.

    * <b>UpgradeTemplate</b>: detailed instructions for upgrading or migrating a
      KubeCluster or an installed part of a KubeCluster. 
  title: Chkk API
  version: '1.0'
servers: []
security: []
paths:
  /packages/{package}/:
    get:
      tags:
        - Package
      summary: Get Package
      description: >
        Gets a single Package


        A <em>Package</em> is a named bundle of software that is bundled (and

        identified) in the format of a specific PackageSystem.


        A <em>PackageSystem</em> is an identifier of a packaging ecosystem.


        Packages can use one of the following PackageSystems:


        * <b>helm</b> for Helm charts

        * <b>kube</b> for raw YAML manifests or Kustomize overlays that install
        one or
          more resources

        A Package is identified by a globally-unique ID field which is a UUID
        string

        prefixed with the string 'pkg_', for example

        'pkg_c42014e7-baf5-4ec6-a502-858f98dca7c8'.


        A Package may be associated with one or more Projects and zero or more

        ProjectComponents.


        A Package may have one or more links associated with it. There are two
        types

        of links that hold special significance to a package: 'package.archive'
        and

        'package.source'. The 'package.archive' link is used to indicate the
        location

        of the package's archive, which is the file that contains the package's

        contents. The 'package.source' link is used to indicate a location on
        the web

        where the package may be observed in an un-archived format. For example,
        the

        cert-manager helm chart package can have the following links


        - 'package.archive': https:charts.jetstack.io/cert-manager

        - 'package.source':
        https:github.com/cert-manager/cert-manager/tree/master/deploy/charts/cert-manager


        A Package may have zero or more aliases associated with it in the
        'Aliases'

        field. An alias for a Package is a human readable string that uniquely

        identifies the Package.


        A Package may be associated with one or more ProjectComponents. Packages
        with

        PackageSystem <b>helm</b> or <b>kube</b> are associated with
        ProjectComponents

        via the Package's collection of PackageComponents. A PackageComponent,
        which

        corresponds to a specific Resource of Kind Deployment, DaemonSet or

        StatefulSet, may reference one or more Docker Images. Those Docker
        Images

        correspond to a ProjectComponent for one or more Projects.
      operationId: package-get
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Package'
          description: OK
        default:
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/ErrorModel'
          description: Error
components:
  schemas:
    Package:
      additionalProperties: false
      properties:
        $schema:
          description: A URL to the JSON Schema for this object.
          examples:
            - https://example.com/schemas/Package.json
          format: uri
          readOnly: true
          type: string
        aliases:
          description: >-
            Optional set of string aliases for the Package. Must be globally
            unique.
          examples:
            - - helm-prom
          items:
            type: string
          type:
            - array
            - 'null'
        created_by:
          description: user who created the record.
          type: string
        created_on:
          description: timestamp of when the record was created.
          format: date-time
          type: string
        description:
          description: Optional long-form description of the Package.
          type: string
        id:
          description: unique identifier for the Package record.
          examples:
            - pkg_cec05b17-80d8-498f-8a38-fc8392604a5a
          type: string
        last_modified_by:
          description: user who last modified the record.
          type: string
        last_modified_on:
          description: timestamp of when the record was last modified.
          format: date-time
          type: string
        system:
          description: System is the PackageSystem for the Package.
          enum:
            - helm
            - kustomize
            - kube
          examples:
            - helm
          type: string
        title:
          description: Display name for the Package.
          examples:
            - Prometheus Helm Chart
          type: string
        versioning:
          $ref: '#/components/schemas/Versioning'
          description: >-
            An optional object containing information about the Package's
            versioning and release model.
      required:
        - system
        - title
        - id
        - created_by
        - created_on
        - last_modified_by
        - last_modified_on
      type: object
    ErrorModel:
      additionalProperties: false
      properties:
        $schema:
          description: A URL to the JSON Schema for this object.
          examples:
            - https://example.com/schemas/ErrorModel.json
          format: uri
          readOnly: true
          type: string
        detail:
          description: >-
            A human-readable explanation specific to this occurrence of the
            problem.
          examples:
            - Property foo is required but is missing.
          type: string
        errors:
          description: Optional list of individual error details
          items:
            $ref: '#/components/schemas/ErrorDetail'
          type:
            - array
            - 'null'
        instance:
          description: >-
            A URI reference that identifies the specific occurrence of the
            problem.
          examples:
            - https://example.com/error-log/abc123
          format: uri
          type: string
        status:
          description: HTTP status code
          examples:
            - 400
          format: int64
          type: integer
        title:
          description: >-
            A short, human-readable summary of the problem type. This value
            should not change between occurrences of the error.
          examples:
            - Bad Request
          type: string
        type:
          default: about:blank
          description: A URI reference to human-readable documentation for the error.
          examples:
            - https://example.com/errors/example
          format: uri
          type: string
      type: object
    Versioning:
      additionalProperties: false
      properties:
        release_cycle:
          default: none
          description: Release cycle the Project or Package uses.
          enum:
            - none
            - regular
            - adhoc
          examples:
            - regular
          type: string
        release_interval_days:
          description: >-
            When ReleaseCycle is 'regular', indicates the interval in days that
            the Project or Package or Project or Package <em>intends</em> to cut
            <em>new</em> releases.
          format: int64
          minimum: 0
          type: integer
        scheme:
          default: unknown
          description: Versioning scheme the Project or Package uses.
          enum:
            - semantic
            - year-with-number
            - calver
            - unknown
          examples:
            - semantic
          type: string
        support_model:
          default: none
          description: The support model the Project or Package follows regarding releases.
          enum:
            - rolling
            - none
          examples:
            - rolling
          type: string
      required:
        - scheme
        - release_cycle
        - support_model
      type: object
    ErrorDetail:
      additionalProperties: false
      properties:
        location:
          description: >-
            Where the error occurred, e.g. 'body.items[3].tags' or
            'path.thing-id'
          type: string
        message:
          description: Error message text
          type: string
        value:
          description: The value at the given location
      type: object

````